############################################################################
# Copyright (C) 2002 Eric Seigne
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,USA.
############################################################################
# File  : A_nous.tcl
# Author  : David Lucardi
#           mailto: DavidLucardi@aol.com
# Date    : 26/04/2002
# Licence : GNU/GPL Version 2 ou plus
#
# Description:
# ------------
#
# @version
# @author     David Lucardi
# @project
# @copyright  Eric Seigne
#
#
#########################################################################
#!/bin/sh
#A_nous.tcl
# Licence : GNU/GPL Version 2 ou plus
# \
exec wish "$0" ${1+"$@"}


if { [catch {package require Iwidgets}] == 1} {
tk_messageBox -message "Il est ncessaire d'installer le package Iwidgets pour que le menu aide fonctionne" -type ok -title "A nous les nombres"
}

proc showaide {signet} {
catch {
option add *textBackground seashell

set win [iwidgets::hyperhelp .#auto -title "Aide" -modality none -topics {aide}]
    $win showtopic aide#$signet
    $win activate
}
}

#####################################################################"
proc majmenu {} {
global Home
catch {.menu.action.m1 delete 0 end}
catch {.menu.action.m2 delete 0 end}
catch {.menu.action.m3 delete 0 end}
catch {.menu.action.m4 delete 0 end}
catch {.menu.action.m5 delete 0 end}
catch {.menu.action.m6 delete 0 end}
catch {.menu.action.m7 delete 0 end}


set f [open [file join $Home calapa.conf] "r"]
set listdata [gets $f]
close $f
	for {set k 0} {$k < [llength $listdata]} {incr k 1} {
	.menu.action.m1 add command -label "[lindex [lindex [lindex $listdata $k] 0] 0]" -command "lanceappli place1.tcl calapa $k 0"
	}
set f [open [file join $Home barque.conf] "r"]
set listdata [gets $f]
close $f
	for {set k 0} {$k < [llength $listdata]} {incr k 1} {
	.menu.action.m2 add command -label "[lindex [lindex [lindex $listdata $k] 0] 0]" -command "lanceappli place1.tcl barque $k 0"
	}

set f [open [file join $Home train.conf] "r"]
set listdata [gets $f]
close $f
	for {set k 0} {$k < [llength $listdata]} {incr k 1} {
	.menu.action.m3 add command -label "[lindex [lindex [lindex $listdata $k] 0] 0]" -command "lanceappli train.tcl train $k 0"
	}


set f [open [file join $Home constellation.conf] "r"]
set listdata [gets $f]
close $f
	for {set k 0} {$k < [llength $listdata]} {incr k 1} {
	.menu.action.m4 add command -label "[lindex [lindex [lindex $listdata $k] 0] 0]" -command "lanceappli place1.tcl constellation $k 0"
	}

set f [open [file join $Home nombre.conf] "r"]
set listdata [gets $f]
close $f
	for {set k 0} {$k < [llength $listdata]} {incr k 1} {
	.menu.action.m5 add command -label "[lindex [lindex [lindex $listdata $k] 0] 0]" -command "lanceappli place1.tcl nombre $k 0"
	}

set f [open [file join $Home ordinal.conf] "r"]
set listdata [gets $f]
close $f
	for {set k 0} {$k < [llength $listdata]} {incr k 1} {
	.menu.action.m6 add command -label "[lindex [lindex [lindex $listdata $k] 0] 0]" -command "lanceappli ordinal.tcl ordinal $k 0"
	}
set f [open [file join $Home voir.conf] "r"]
set listdata [gets $f]
close $f
	for {set k 0} {$k < [llength $listdata]} {incr k 1} {
	.menu.action.m7 add command -label "[lindex [lindex [lindex $listdata $k] 0] 0]" -command "lanceappli quevoir.tcl voir $k 0"
	}

}


#######################################################################"

proc changehome {} {
global Home basedir baseHome
variable repert
set f [open [file join $baseHome reglage.conf] "w"]
puts $f $repert
close $f
switch $repert {
0 {set Home $baseHome}
1 {set Home $basedir}
}
majmenu
}

source fonts.tcl
source init.tcl
#source utils.tcl
#wm resizable . 0 0
. configure -background #ffff80

menu .menu

# Creation du menu Fichier
menu .menu.fichier -tearoff 0
.menu add cascade -label "Fichier" -menu .menu.fichier
.menu.fichier add cascade -label "Editeur" -menu .menu.fichier.editeur
menu .menu.fichier.editeur -tearoff 0

.menu.fichier.editeur add command -label "Calapa" -command "exec wish editcalapa.tcl calapa &"
.menu.fichier.editeur add command -label "Constellation" -command "exec wish editcalapa.tcl constellation &"
.menu.fichier.editeur add command -label "Nombre" -command "exec wish editcalapa.tcl nombre &"
.menu.fichier.editeur add command -label "Barques" -command "exec wish editbarques.tcl barque &"
.menu.fichier.editeur add command -label "Train" -command "exec wish edittrain.tcl train &"
.menu.fichier.editeur add command -label "Ordinal" -command "exec wish editordinal.tcl ordinal &"
.menu.fichier.editeur add command -label "Que voir" -command "exec wish editvoir.tcl voir &"
.menu.fichier.editeur add command -label "Parcours" -command "exec wish editparcours.tcl parcours &"


.menu.fichier add command -label "Bilans" -command "exec wish bilan.tcl &"
.menu.fichier add sep
.menu.fichier add command -label "Quitter" -command exit

menu .menu.action -tearoff 0
.menu add cascade -label "Activites" -menu .menu.action
menu .menu.action.m1 -tearoff 0
.menu.action add cascade -label "Calapa" -menu .menu.action.m1

menu .menu.action.m2 -tearoff 0 
.menu.action add cascade -label "Barques" -menu .menu.action.m2 
menu .menu.action.m3 -tearoff 0 
.menu.action add cascade -label "Train" -menu .menu.action.m3 
menu .menu.action.m4 -tearoff 0 
.menu.action add cascade -label "Constellation" -menu .menu.action.m4 
menu .menu.action.m5 -tearoff 0 
.menu.action add cascade -label "Nombre" -menu .menu.action.m5 
menu .menu.action.m6 -tearoff 0 
.menu.action add cascade -label "Ordinal" -menu .menu.action.m6
menu .menu.action.m7 -tearoff 0 
.menu.action add cascade -label "Que voir" -menu .menu.action.m7 
 
.menu.action add command -label "Parcours" -command "parcours" 

menu .menu.options -tearoff 0
.menu add cascade -label "Rglages" -menu .menu.options
menu .menu.options.dossier -tearoff 0 
.menu.options add cascade -label "Dossier de travail" -menu .menu.options.dossier
.menu.options.dossier add radio -label "Utilisateur" -variable repert -value 0 -command "changehome"
.menu.options.dossier add radio -label "Systme" -variable repert -value 1 -command "changehome"

set f [open [file join $Home reglage.conf] "r"]
set listdata [gets $f]
close $f
set repert $listdata
changehome

menu .menu.aide -tearoff 0
.menu add cascade -label "?" -menu .menu.aide
.menu.aide add command -label "Aide" -command "showaide general"
#.menu.aide add command -label "Aide" -command "exec wish aide.tcl &"

#menu .menu.aide.help  -tearoff 0

. configure -menu .menu

. configure -background blue
frame .wleft -background blue -height 300 -width 200
pack .wleft -side left


label .wleft.labA1 -text "Calapa" -background blue -wraplength 200 -font $sysFont(t) -pady 6 -justify left -foreground orange
pack .wleft.labA1 -side top -anchor w
bind .wleft.labA1 <1> "lanceappli place1.tcl calapa 0 0"
bind .wleft.labA1 <Any-Enter> ".wleft.labA1 configure -foreground yellow"
bind .wleft.labA1 <Any-Leave> ".wleft.labA1 configure -foreground orange"

label .wleft.labA2 -text "Barques" -background blue -wraplength 200 -font $sysFont(t) -pady 6 -justify left -foreground orange
pack .wleft.labA2 -side top -anchor w
bind .wleft.labA2 <1> "lanceappli place1.tcl barque 0 0"
bind .wleft.labA2 <Any-Enter> ".wleft.labA2 configure -foreground yellow"
bind .wleft.labA2 <Any-Leave> ".wleft.labA2 configure -foreground orange"

label .wleft.labA3 -text "Train" -background blue -wraplength 200 -font $sysFont(t) -pady 6 -justify left -foreground orange
pack .wleft.labA3 -side top -anchor w
bind .wleft.labA3 <1> "lanceappli train.tcl train 0 0"
bind .wleft.labA3 <Any-Enter> ".wleft.labA3 configure -foreground yellow"
bind .wleft.labA3 <Any-Leave> ".wleft.labA3 configure -foreground orange"

label .wleft.labA4 -text "Que voir" -background blue -wraplength 200 -font $sysFont(t) -pady 6 -justify left -foreground orange
pack .wleft.labA4 -side top -anchor w
bind .wleft.labA4 <1> "lanceappli quevoir.tcl voir 0 0"
bind .wleft.labA4 <Any-Enter> ".wleft.labA4 configure -foreground yellow"
bind .wleft.labA4 <Any-Leave> ".wleft.labA4 configure -foreground orange"

frame .wcenter -background blue -height 300 -width 200
pack .wcenter -side left

frame .wright -background blue -height 300 -width 200
pack .wright -side left
label .wright.labA2 -text "Constellation" -background blue -wraplength 200 -font $sysFont(t) -pady 6 -justify right -foreground orange
pack .wright.labA2 -side top -anchor e
bind .wright.labA2 <1> "lanceappli place1.tcl constellation 0 0"
bind .wright.labA2 <Any-Enter> ".wright.labA2 configure -foreground yellow"
bind .wright.labA2 <Any-Leave> ".wright.labA2 configure -foreground orange"

label .wright.labA3 -text "Nombre" -background blue -wraplength 200 -font $sysFont(t) -pady 6 -justify right -foreground orange
pack .wright.labA3 -side top -anchor e
bind .wright.labA3 <1> "lanceappli place1.tcl nombre 0 0"
bind .wright.labA3 <Any-Enter> ".wright.labA3 configure -foreground yellow"
bind .wright.labA3 <Any-Leave> ".wright.labA3 configure -foreground orange"

label .wright.labA4 -text "Ordinal" -background blue -wraplength 200 -font $sysFont(t) -pady 6 -justify right -foreground orange
pack .wright.labA4 -side top -anchor e
bind .wright.labA4 <1> "lanceappli ordinal.tcl ordinal 0 0"
bind .wright.labA4 <Any-Enter> ".wright.labA4 configure -foreground yellow"
bind .wright.labA4 <Any-Leave> ".wright.labA4 configure -foreground orange"


set myimage [image create photo -file sysdata/background.gif]
label .wcenter.imagedisplayer -image $myimage -background blue
pack .wcenter.imagedisplayer -side top
label .wcenter.labA1 -text "Parcours" -background blue -wraplength 200 -font $sysFont(t) -pady 6 -justify right -foreground orange
pack .wcenter.labA1 -side top
bind .wcenter.labA1 <1> "parcours"
bind .wcenter.labA1 <Any-Enter> ".wcenter.labA1 configure -foreground yellow"
bind .wcenter.labA1 <Any-Leave> ".wcenter.labA1 configure -foreground orange"

majmenu



############
# Bindings #
############
bind . <Control-q> {exit}

bind . <FocusIn> {majmenu}



proc lanceappli {appli what niveau parcours} {
set appli [file join $appli]
#appli.tcl activit index_dans_le_scnario flag_parcours
exec wish $appli $what $niveau $parcours &
}


proc parcours {} {
global Home
	set f [open [file join $Home parcours.conf] "r"]
	set listparcours [gets $f]
	close $f
	set activite [lindex [lindex $listparcours 0] 0]
	set ext .conf
	set f [open [file join $Home [lindex $activite 0]$ext] "r"]
	set listactivite [gets $f]
	close $f
	set compt 0
		foreach item $listactivite {
		if {[string first [lindex [lindex $listparcours 0] 1] $item] != -1} {
		break}
		incr compt
		}
		if {$compt >= [llength $listactivite ]} {
		tk_messageBox -message "Le scnario [lindex $listparcours 0] n'existe pas" -type ok -title "A nous les nombres"
		return
		}
		if {[lindex $activite 0] == "calapa"} {
		#appli.tcl activit index_dans_le_scnario flag_parcours index_dans_le_parcours
		exec wish place1.tcl calapa $compt 1 0 &
		}
		if {[lindex $activite 0] == "constellation"} {
		exec wish place1.tcl constellation $compt 1 0 &
		}
		if {[lindex $activite 0] == "nombre"} {
		exec wish place1.tcl nombre $compt 1 0 &
		}
		if {[lindex $activite 0] == "barque"} {
		exec wish place1.tcl barque $compt 1 0 &
		}
		if {[lindex $activite 0] == "train"} {
		exec wish train.tcl train $compt 1 0 &
		}
		if {[lindex $activite 0] == "ordinal"} {
		exec wish ordinal.tcl ordinal $compt 1 0 &
		}
		if {[lindex $activite 0] == "voir"} {
		exec wish quevoir.tcl voir $compt 1 0 &
		}

}






