#!/bin/sh
#init.tcl
# \
exec wish "$0" ${1+"$@"}

#*************************************************************************
#  Copyright (C) 2002 David Lucardi <davidlucardi@aol.com>
#  Copyright (C) 2002 Andr Connes <andre.connes@toulouse.iufm.fr>
# 
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
# 
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# 
#**************************************************************************
#  File  : init.tcl
#  Author  : David Lucardi <davidlucardi@aol.com>
#  Modifier:
#  Date    : 24/04/2002
#  Licence : GNU/GPL Version 2 ou plus
# 
#  Description:
#  ------------
# 
#  @version    
#  @author     David Lucardi
#  @modifier   
#  @project    Le terrier
#  @copyright  David Lucardi
#  @copyright  Andr Connes
# 
#***********************************************************************

global Home basedir envir baseHome
set basedir [file dir $argv0]
cd $basedir
if {$env(HOME) == "c:\\"} {
set Home $basedir
} else {
set Home [file join $env(HOME) leterrier A_nous]
}
set baseHome $Home

#wm resizable . 0 0

if {![file exists [file join $Home]]} {
file mkdir [file join $Home]
	foreach item {calapa.conf barque.conf train.conf constellation.conf nombre.conf train.conf ordinal.conf reglage.conf parcours.conf} {
	file copy -force [file join $item] [file join $Home]
	}
}

#upgrade version
if {![file exists [file join $Home voir.conf]]} {
	file copy -force [file join voir.conf] [file join $Home]
}

switch $tcl_platform(platform) {
    unix {
	if {![file exists [file join  /var leterrier A_nous]]} {
	file mkdir [file join  /var leterrier A_nous]
	}

    }
    windows {
	if {![file exists [file join A_nous Log]]} {
	file mkdir [file join A_nous Log]
	}
	
    	}
}

switch $tcl_platform(platform) {
    unix {
	set LogHome [file join /var leterrier A_nous]
    }
    windows {
	set LogHome [file join A_nous Log]
    	}
}

if {$tcl_platform(user) != ""} {
     set user [file join $LogHome $tcl_platform(user).log]
     } else {
     set user [file join $LogHome a_nous.log]
     }


